#include "xbasic_types.h"
#include "xio.h"

typedef struct _node {
  int x, c;
  struct _node *l, *r;
} node;

void tree_ins(node **p, int x)
{
  if(!*p) {
    *p=(node *)malloc(sizeof(node));

    //print("malloc:"); putnum(*p); print("\n");
    
    if(!*p){putnum(x); print(" Out of heap memory\n"); exit(-1);}

    (*p)->x = x;
    (*p)->c = 1;
    (*p)->l = (*p)->r = 0;
  }
  else 
    if((*p)->x == x) (*p)->c++; else 
      if((*p)->x > x) tree_ins(&(*p)->l, x);
      else tree_ins(&(*p)->r, x);
}

void tree_dump(node *p)
{
  if(p){
    tree_dump(p->l);
    putnum(p->x); print(":"); putnum(p->c); print("\n");
    tree_dump(p->r);
  }
}

int tree_maxcnt(node *p)
{
  int x, x1;
  if(!p) return 0;
  x = p->c;
  x1 = tree_maxcnt(p->l); if(x1>x) x = x1;
  x1 = tree_maxcnt(p->r); if(x1>x) x = x1;
  return x;
}

main()
{

  node *tree;
  int i;

  // for(i=0;i<0x80000;i+=4) XIo_Out32(0xff000000 + i, 0);
  print("\n\n\n\nHello\n");

  tree=0;
  for(i=0;i<1000000;i++)
    tree_ins(&tree, rand()& 0x3FFF); // 64 numbers

  //  print("The results are:\n");
  //  tree_dump(tree);

  print("max count is:");putnum(tree_maxcnt(tree)); print("\n");

  print("Bye\n");

}
