/* Simple print hello world to standard output device

*/ 

#include "xbasic_types.h"
#include "xio.h"

#define W 640
#define H 480
#define VGA_START 0x00800000

#define RED 0xE0
#define GREEN 0x1C
#define BLUE 0x03

void draw_backgrd()
{
	int x, y;
	// erasing screen
	for(x=0; x<H*W; x++)
	  XIo_Out8(VGA_START + x, 0);

	// red border
	for(x=0;x<W;x++){
	  XIo_Out8(VGA_START + x, RED);
	  XIo_Out8(VGA_START + (H-1)*W + x, RED);
	}
	for(y=0;y<H;y++){
	  XIo_Out8(VGA_START + y*W , RED);
          XIo_Out8(VGA_START + y*W + W - 1, RED);
	}

	// white lines
	for(x=400; x<600; x+=20)
	  for(y=20; y<100; y++){
	    XIo_Out8(VGA_START + y*W +x, RED|GREEN|BLUE);
	    XIo_Out8(VGA_START + y*W +x+1, RED|GREEN|BLUE);
	  }

	// green square
	for(y=100;y<150;y++)
	  for(x=100;x<150;x++)
	    XIo_Out8(VGA_START + y*W + x, GREEN);


	// blue circle
	for(y=-100; y<100; y++)
	  for(x=0;x*x+y*y<10000;x++){
	    XIo_Out8(VGA_START + (y+280)*W + x +400, BLUE);
	    XIo_Out8(VGA_START + (y+280)*W - x +400, BLUE);
	  }

	// YELLOW TRIANGLE
	for(y=0;y<100;y++)
	  for(x=-y;x<y;x++)
	    XIo_Out8(VGA_START + (y+310)*W + x + 150, GREEN | RED);

}

#define R 7
#define NS 20
Xuint8 tmp[NS][R+R+1][R+R+1];
Xuint8 sprites[NS][R+R+1][R+R+1];

void make_sprites()
{
  int i,j,ns;
  Xuint8 rgb;

  for(ns=0;ns<NS;ns++){

    rgb = 15 << (ns&7);

    for(j=-R;j<=R;j++)
      for(i=-R;i<=R;i++)
	sprites[ns][j+R][i+R] = i*i+j*j<=R*R ?  rgb : 0;
  }

}

void tmp2screen(int ns, int x, int y)
{
  int i,j;

  for(i=-R;i<=R;i++)
    for(j=-R;j<=R;j++)
      XIo_Out8(VGA_START + (y+j)*W + (x+i), tmp[ns][R+i][R+j]);
}

void draw_sprite(int ns, int x, int y)
{
  int i,j;

  for(i=-R;i<=R;i++)
    for(j=-R;j<=R;j++)
      XIo_Out8(VGA_START + (y+j)*W + (x+i), sprites[ns][R+i][R+j]);
}

void screen2tmp(int ns, int x, int y)
{

  int i,j;

 for(i=-R;i<=R;i++)
    for(j=-R;j<=R;j++)
      tmp[ns][R+i][R+j]=XIo_In8(VGA_START + (y+j)*W + (x+i));
}

main() 
{

  int x[NS],y[NS], dx[NS], dy[NS], t,i;

  microblaze_enable_icache();

  print ("Hello\n");

  draw_backgrd();
  make_sprites();

  for(i=0;i<NS;i++){
    x[i]=50+i*20; y[i]=50+i*20;
        dx[i]=(i&1?3:-4)+(i&3?1:-1);
        dy[i]=(i&2?3:-4)+(i&4?1:-1);
  }

  print ("Bye\n");
  
  while(1){

    for(i=0;i<NS;i++){
      screen2tmp(i,x[i],y[i]);
      draw_sprite(i, x[i],y[i]);
    }
    for(t=0;t<100000;t++);
    for(i=NS-1;i>=0;i--){
      tmp2screen(i,x[i],y[i]);
    }

    for(i=0;i<NS;i++){

    x[i]+=dx[i]; y[i]+=dy[i];
    
    if(x[i]<R){x[i]=R;dx[i]=-dx[i];}
    if(x[i]>W-R){x[i]=W-R;dx[i]=-dx[i];}

    if(y[i]<R){y[i]=R;dy[i]=-dy[i];}
    if(y[i]>H-R){y[i]=H-R;dy[i]=-dy[i];}

    }
	
  }
	

}   
