/* Simple print hello world to standard output device

*/ 

#include "xbasic_types.h"
#include "xio.h"

#include "video8.h"


extern unsigned char fontdata_8x8[];

void clear_screen()
{
  int i;
  for(i=0;i<VGA_W*VGA_H;i+=4)
    XIo_Out32(VGA_START_ADDRESS + i, 0);
}

static Xuint32 mask4[16]={
  0x00000000, 0x000000FF, 0x0000FF00, 0x0000FFFF,
  0x00FF0000, 0x00FF00FF, 0x00FFFF00, 0x00FFFFFF,
  0xFF000000, 0xFF0000FF, 0xFF00FF00, 0xFF00FFFF,
  0xFFFF0000, 0xFFFF00FF, 0xFFFFFF00, 0xFFFFFFFF
};



void draw_char(int x, int y, unsigned char c)
{
  int i,j;
  int pix8;
  Xuint32 vaddr;

  vaddr = VGA_START_ADDRESS +( (y*VGA_W + x)<<3);

  for(i=0;i<8;i++){
    pix8 = fontdata_8x8[(c<<3)+i];

    XIo_Out32(vaddr, mask4[pix8 >> 4]);
    XIo_Out32(vaddr + 4, mask4[pix8 & 0x0f]);

    vaddr += VGA_W;
  }
}

void draw_string(int x, int y, char *s)
{
  while(*s) draw_char(x++,y,*s++);
}

void draw_hex_num(int x, int y, Xuint32 n)
{

  int i,d;

  for(i=0;i<8;i++){
    d=(n>>28);
    draw_char(x++,y, d>9 ? d-10+'A' : d+'0');
    n <<=4;
  }

}

void draw_dec_num(int x, int y, int no)
{
  char buf[8];
  int i;

  for(i=6;i>=0;i--){
	buf[i] = '0' + (no%10);
	no = no / 10;
  }
  buf[7]=0;
  draw_string(x, y, buf);
}
